clear 

%% Python result
fileID = fopen('python_loss_array.txt','r');
formatSpec = '%f';
python_loss_array = fscanf(fileID,formatSpec);
fclose(fileID);

fileID = fopen('python_runtime_array.txt','r');
formatSpec = '%f';
python_runtime_array = fscanf(fileID,formatSpec);
fclose(fileID);


% % find values in N that are cloest to elements in V
% (https://uk.mathworks.com/matlabcentral/answers/152301-find-closest-value-in-array#answer_336210)
% V = randi(10,[5 1])
% N = randi(10,[5 1])
% A = repmat(N,[1 length(V)])
% [minValue,closestIndex] = min(abs(A-V.'))
% closestValue = N(closestIndex) 

reg_time = linspace(0,2/44,2001)'; %V
A = repmat(python_runtime_array,[1 length(reg_time)]); %large memory requirement
[minValue,closestIndex] = min(abs(A-reg_time.'));
TimeclosestValue = python_runtime_array(closestIndex) ;
LossclosestValue = python_loss_array(closestIndex);

clear A %A requires large memory

mean_time_difference = mean(abs(TimeclosestValue-reg_time))

%averaged over the 1001 data points only
Average_loss_python = mean(LossclosestValue(1001:2001))

%% COMSOL result

COMSOL = readmatrix('COMSOL.txt', 'NumHeaderLines',9, "delimiter",",");
COMSOL=COMSOL(1,3:end);

Average_loss_comsol = mean(COMSOL(1001:2001))


%% Matlab result
% matlab result with no laplacian term
load("P");

Average_loss_matlab = mean(P(1001:2001))

%% plot graph
time_array = linspace(0,2/44,2001);

figure(201)
plot(TimeclosestValue,LossclosestValue, 'DisplayName','Python')
hold on
plot(time_array,P, 'DisplayName','Matlab')
hold on
plot(time_array,COMSOL','DisplayName','COMSOL')
hold off
xlabel('Time [s]')
ylabel('Instantaneous loss [W/m]')
grid on
legend

ax = gca;
exportgraphics(ax,'machine_result.pdf','ContentType','vector')